import evdev
import threading
import sys
import time
import can
try:
  import RPi.GPIO as GPIO
except ImportError:
  pass
from evdev import InputDevice, categorize, ecodes

level = 0

CAN_CHANNEL="can0"
CAN_INTERFACE="socketcan_ctypes"
CAN_INTERFACE="socketcan"

GPIOF = 18
GPIOB = 17
GPIOL = 22
GPIOR = 23
GPIOF2 = 24
GPIOR2 = 21

def incLevel():
    global level
    global synccount
    global synccount2
    synccount = 0
    synccount2 = 0
    level = level + 1
    if level == 3:
        level = 0

def decLevel():
    global level
    global synccount
    global synccount2
    synccount = 0
    synccount2 = 0
    if level == 0:
        level = 3
    level = level - 1

def getDevice():
    devices = [evdev.InputDevice(path) for path in evdev.list_devices()]
    for device in devices:
        print (device.path, device.name, device.phys)
        if device.name == "Logitech Gamepad F310":
            return device
        if device.name == "USB,2-axis 8-button gamepad  ":
            return device
        if device.name == "BUFFALO INC. BUFFALO BGC-FC801 USB Gamepad":
            return device
        if device.name == "BUFFALO INC. BUFFALO BGC-FC801 USB Gamepad ":
            return device
    return 0

accel = 0
handle = 0
gpioenabled = 0

def handleEventKey(ev):
    global accel, handle, level
    if ev.type == 0:
        return
    print ("js>", ev.type, ev.code, ev.value)
    if ev.code == 288:
        print ("btnA>", ev.type, ev.code, ev.value)
        if ev.value == 1:
            accel = 1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 289:
        print ("btnB>", ev.type, ev.code, ev.value)
        if ev.value == 1:
            accel = -1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 293:
        if ev.value == 1:
            incLevel()
    elif ev.code == 292:
        if ev.value == 1:
            decLevel()
    return 0

def handleEvent3(ev):
    global accel, handle, level
    if ev.type == 0:
        return
    print ("js>", ev.type, ev.code, ev.value)
    if ev.type == 3 and ev.code == 0:
        if ev.value == 0:
            handle = 1
        elif ev.value == 255:
            handle = -1
        elif ev.value > 126 and ev.value < 130:
            handle = 0
    elif ev.code == 288:
        print ("btnA>", ev.type, ev.code, ev.value)
        if ev.value == 1:
            accel = 1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 289:
        print ("btnB>", ev.type, ev.code, ev.value)
        if ev.value == 1:
            accel = -1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 293:
        if ev.value == 1:
            incLevel()
    elif ev.code == 292:
        if ev.value == 1:
            decLevel()
    return 0

def handleEvent2(ev):
    global accel, handle, level
    print (ev.type, ev.code, ev.value)
    if ev.type == 3 and ev.code == 0:
        if ev.value == 0:
            handle = 1
        elif ev.value == 255:
            handle = -1
        elif ev.value == 128:
            handle = 0
    elif ev.code == 288:
        if ev.value == 1:
            accel = 1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 289:
        if ev.value == 1:
            accel = -1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 293:
        if ev.value == 1:
            incLevel()
    elif ev.code == 292:
        if ev.value == 1:
            decLevel()
    return 0

def handleEvent1(ev):
    global accel, handle, level
    if ev.code == 17:
        if ev.value == -1:
            accel = 1
        elif ev.value == 1:
            accel = -1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 305:
        if ev.value == 1:
            accel = 1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 304:
        if ev.value == 1:
            accel = -1
        elif ev.value == 0:
            accel = 0
    elif ev.code == 16:
        if ev.value == -1:
            handle = 1
        elif ev.value == 1:
            handle = -1
        elif ev.value == 0:
            handle = 0
    elif ev.code == 311:
        if ev.value == 1:
          incLevel()
    elif ev.code == 310:
        if ev.value == 1:
          decLevel()
    return 0

def createEventCAN1(bus):
    global accel, handle, level
    msg = bytearray(4)
    if handle == 1:
        msg[1] = 0x01
    elif handle == -1:
        msg[1] = 0x08
    else:
        msg[1] = 0x09
    if accel == 1:
        msg[2] = 0x04
        msg[3] = 0x01
    elif accel == -1:
        msg[2] = 0x04
        msg[3] = 0x00
    else:
        msg[2] = 0x00
        msg[3] = 0x00
    message = can.Message(arbitration_id=0x07b, extended_id=False, data=msg)
    bus.send(message, timeout=0.1)

synccount = 0
synccount2 = 0
def createEventCAN2(bus):
    global accel, handle, level
    global synccount
    msg = bytearray(6)
    msg[0] = synccount & 0xff
    msg[1] = (synccount >> 8) & 0xff
    synccount += 1
    if handle == 1:
        msg[2] = 0x80
    elif handle == -1:
        msg[2] = 0x20
    else:
        msg[2] = 0xa0
    if accel == 1:
        msg[3] = 0x20
        msg[4] = 0xa8
    elif accel == -1:
        msg[3] = 0x20
        msg[4] = 0x54
    else:
        msg[3] = 0x00
        msg[4] = 0x9f
    message = can.Message(arbitration_id=0x0aa, extended_id=False, data=msg)
    bus.send(message, timeout=0.1)

def handleEventCAN1(bus, msg):
    global accel, handle, level
    if len(msg.data) != 4:
        return
    if msg.arbitration_id != 0x07b:
        return
    msgdata = msg.data
    if msgdata[0] != 0x00:
        return
    handledata = msgdata[1]
    acceldata = msgdata[2]
    dirdata = msgdata[3]
    print ("can > ", handledata, acceldata, dirdata, level)
    if handledata == 0x1:
        handle = 1
    elif handledata == 0x8:
        handle = -1
    elif handledata == 0x9:
        handle = 0
    else:
        handle = 0
    if acceldata != 0x0:
        if dirdata == 0x1:
            accel = 1
        elif dirdata == 0x0:
            accel = -1
    else:
        accel = 0

def handleEventCAN2(bus, msg):
    global accel, handle, level
    global synccount2
    if len(msg.data) != 6:
        return
    if msg.arbitration_id != 0x0aa:
        return
    msgdata = msg.data
    if msgdata[5] != 0x00:
        return
    synccount2new = (msgdata[1] << 8) | msgdata[0]
    if (synccount2new < synccount2) or (synccount2new > synccount2 + 10):
        return
    synccount2 = synccount2new
    handledata = msgdata[2]
    acceldata = msgdata[3]
    dirdata = msgdata[4]
    print ("can > ", synccount2, handledata, acceldata, dirdata, level)
    if handledata == 0x80:
        handle = 1
    elif handledata == 0x20:
        handle = -1
    elif handledata == 0xa0:
        handle = 0
    else:
        handle = 0
    if acceldata != 0x0:
        if dirdata == 0xa8:
            accel = 1
        elif dirdata == 0x54:
            accel = -1
    else:
        accel = 0

def handleEventCAN(bus, msg):
    global level
    if level == 0:
        handleEventCAN1(bus, msg)
    elif level == 1:
        handleEventCAN2(bus, msg)
    else:
        handleEventCAN1(bus, msg)

def createEventCAN(bus):
    global level
    if level == 0:
        createEventCAN1(bus)
    elif level == 1:
        createEventCAN2(bus)
    elif level == 2:
        createEventCAN3(bus)
    else:
        createEventCAN1(bus)

def initGPIO2():
    global gpioenabled
    try:
      GPIO.setwarnings(False)
      GPIO.setmode(GPIO.BCM)
      GPIO.setup(GPIOF2, GPIO.OUT); GPIO.output(GPIOF2, GPIO.LOW)
      GPIO.setup(GPIOR2, GPIO.OUT); GPIO.output(GPIOR2, GPIO.LOW)
      gpioenabled = 1
    except NameError:
      return

def initGPIO():
    global gpioenabled
    initGPIO2()
    try:
      GPIO.setwarnings(False)
      GPIO.setmode(GPIO.BCM)
      GPIO.setup(GPIOF, GPIO.OUT); GPIO.output(GPIOF, GPIO.HIGH)
      GPIO.setup(GPIOB, GPIO.OUT); GPIO.output(GPIOB, GPIO.HIGH)
      GPIO.setup(GPIOL, GPIO.OUT); GPIO.output(GPIOL, GPIO.HIGH)
      GPIO.setup(GPIOR, GPIO.OUT); GPIO.output(GPIOR, GPIO.HIGH)
      gpioenabled = 1
    except NameError:
      return

def dohandleGPIO2(val):
    global gpioenabled
    if gpioenabled != 1:
        return
    if val == 0:
      GPIO.setup(GPIOR2, GPIO.OUT)
      GPIO.output(GPIOR2, GPIO.LOW)
    elif val == 1:
      GPIO.setup(GPIOR2, GPIO.OUT)
      GPIO.output(GPIOR2, GPIO.HIGH)
    elif val == -1:
      GPIO.setup(GPIOR2, GPIO.IN, pull_up_down=GPIO.PUD_UP)

def doaccelGPIO2(val):
    global gpioenabled
    if gpioenabled != 1:
        return
    if val == 0:
      GPIO.setup(GPIOF2, GPIO.OUT)
      GPIO.output(GPIOF2, GPIO.LOW)
    elif val == 1:
      GPIO.setup(GPIOF2, GPIO.OUT)
      GPIO.output(GPIOF2, GPIO.HIGH)
    elif val == -1:
      GPIO.setup(GPIOF2, GPIO.IN, pull_up_down=GPIO.PUD_UP)

def dohandleGPIO(val):
    global gpioenabled
    if gpioenabled != 1:
        return
    dohandleGPIO2(val)
    if val == 0:
      GPIO.output(GPIOL, GPIO.HIGH)
      GPIO.output(GPIOR, GPIO.HIGH)
    elif val == 1:
      GPIO.output(GPIOL, GPIO.LOW)
      GPIO.output(GPIOR, GPIO.HIGH)
    elif val == -1:
      GPIO.output(GPIOL, GPIO.HIGH)
      GPIO.output(GPIOR, GPIO.LOW)

def doaccelGPIO(val):
    global gpioenabled
    if gpioenabled != 1:
        return
    doaccelGPIO2(val)
    if val == 0:
      GPIO.output(GPIOF, GPIO.HIGH)
      GPIO.output(GPIOB, GPIO.HIGH)
    elif val == 1:
      GPIO.output(GPIOF, GPIO.LOW)
      GPIO.output(GPIOB, GPIO.HIGH)
    elif val == -1:
      GPIO.output(GPIOF, GPIO.HIGH)
      GPIO.output(GPIOB, GPIO.LOW)

def mainloopCAN():
    global accel, handle, level
    initGPIO()
    bus = can.interface.Bus(channel=CAN_CHANNEL, receive_own_messages=True, bustype=CAN_INTERFACE)
    print bus
    while True:
      accelbak = accel
      handlebak = handle
      for msg in bus:
          print msg
          handleEventCAN(bus, msg)
          if handle != handlebak:
            print (accel, handle, level)
            handlebak = handle
            dohandleGPIO(handle)
          if accel != accelbak:
            print (accel, handle, level)
            accelbak = accel
            doaccelGPIO(accel)

def mainloopCAN2():
    global accel, handle, level
    import can
    bus = can.interface.Bus(channel=CAN_CHANNEL, receive_own_messages=True, bustype=CAN_INTERFACE)
    print bus
    while True:
      time.sleep(0.25)
      createEventCAN(bus)

def mainloopJS():
    device = getDevice()
    if device == 0:
       print "joystick device not found."
       return
    for event in device.read_loop():
      if device.name == "Logitech Gamepad F310":
        handleEvent1(event)
      elif device.name == "BUFFALO INC. BUFFALO BGC-FC801 USB Gamepad":
        handleEvent2(event)
      elif device.name == "BUFFALO INC. BUFFALO BGC-FC801 USB Gamepad ":
        handleEvent2(event)
      elif device.name == "USB,2-axis 8-button gamepad  ":
        handleEvent3(event)

if __name__ == "__main__":
    thread_1 = threading.Thread(target=mainloopJS)
    thread_1.start()
    thread_2 = threading.Thread(target=mainloopCAN)
    thread_2.start()
    thread_3 = threading.Thread(target=mainloopCAN2)
    thread_3.start()
